<script setup lang="ts">
import type { Member } from '@/types/Member'
import { nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import { useMemberStore } from '@/stores/member'
import { useLoadingStore } from '@/stores/loading'

const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Tel',
    key: 'tel',
    value: 'tel'
  },
  {
    title: 'Point',
    key: 'point',
    value: 'point'
  },
  {
    title: 'Total Spent',
    key: 'spent',
    value: 'spent'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const memberStore = useMemberStore()
const form = ref(false)
const loading = ref(false)
const dialog = ref(false)
const dialogDelete = ref(false)
const refForm = ref<VForm | null>(null)
let editedIndex = -1

function onSubmit() {}
function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    memberStore.clear()
  })
}

async function deleteItemConfirm() {
  await memberStore.deleteMember()
  closeDelete()
}

async function editItem(item: Member) {
  if (!item.id) return
  await memberStore.getMember(item.id)
  dialog.value = true
}

async function deleteItem(item: Member) {
  if (!item.id) return
  await memberStore.getMember(item.id)
  dialogDelete.value = true
  editedIndex = -1
}

onMounted(() => {
  memberStore.getMembers()
})
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    memberStore.clear()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await memberStore.saveMember()
  closeDialog()
}
</script>
<template>
  <div>
    <v-data-table :headers="headers" :items="memberStore.members" class="custom-datatable">
      <template v-slot:top>
        <v-toolbar flat style="background-color: rgb(247, 156, 82)">
          <v-toolbar-title style="color: white; font-weight: bold; font-size: 30px"
            >Member Management</v-toolbar-title
          >
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn
                prepend-icon="mdi-plus"
                outlined
                v-bind="props"
                style="color: white; background-color: green"
                >New Member</v-btn
              >
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Member Member</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="memberStore.editedMember.name"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Name"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="memberStore.editedMember.tel"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          class="mb-2"
                          clearable
                          label="Tel"
                        ></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field
                          v-model="memberStore.editedMember.point"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']"
                          clearable
                          label="Point"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>***indicates required field***</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()">Close</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()">Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- </v-row> -->
          <!-- Delete Dialog -->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card class="center-card" elevation="5">
              <v-icon
                icon="mdi-alert-circle-outline"
                size="110px"
                style="margin-top: 5%; color: rgba(255, 151, 4, 1)"
              ></v-icon>
              <v-card-text>Are you sure you want to delete this item?</v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn
                  style="background-color: rgba(223, 50, 46, 1); color: white"
                  rounded="lg"
                  @click="closeDelete"
                  ><span style="color: white">Cancel</span></v-btn
                >
                <v-btn
                  style="background-color: rgba(45, 133, 219, 1); color: white"
                  rounded="lg"
                  @click="deleteItemConfirm"
                  ><span style="color: white">OK</span></v-btn
                >
                <v-spacer></v-spacer>
              </v-card-actions>
              <div style="margin-bottom: 5%"></div>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" color="blue-accent-4" class="me-2" @click="editItem(item)"
          >mdi-pencil</v-icon
        >
        <v-icon size="small" color="red-accent-4" @click="deleteItem(item)">mdi-delete</v-icon>
      </template>
      <template v-slot:no-data>
        <v-btn color="primary" @click="memberStore.getMembers()">Reset</v-btn>
      </template>
    </v-data-table>
  </div>
</template>
<style scoped>
.custom-datatable th {
  background-color: rgb(236, 235, 235);
  color: black;
  font-weight: bold !important; 
  font-size: 15px; /* Adjust the font size as needed */
}

.center-card {
  display: flex;
  justify-content: center;
  align-items: center;
}
</style>
